include doszip.inc
include string.inc
include keyb.inc
include io.inc
include iost.inc
include stdio.inc
include progress.inc

; Make List File from selection set

public  cp_ziplst
;public  CRLF$

extrn	format_u:byte
extrn	format_lu:byte
extrn	format_lst:byte
extrn	filelist_bat:byte

MKLID_LIST	equ 1*16
MKLID_APPEND	equ 2*16
MKLID_FORMAT	equ 3*16
MKLID_UNIX	equ 4*16
MKLID_EXLCD	equ 5*16
MKLID_EXLDRV	equ 6*16
MKLID_FILTER	equ 9*16

.data

$BACK db '\'		; 5C
BACK$ db '\',0		; '\'
$SIGN db '\'		; 25
SIGN$ db '%',0		; '%'
$TAB9 db '\t',0		; 09
$CRLF db '\n',0		; 0D 0A
TAB9$ db 9,0
CRLF$ db 0Dh,0Ah
NULL$ db 0

$FILE db '%f',0		; File name
$PATH db '%p',0		; Path part of file
$CURD db '%cd',0	; Current directory
$HOME db '%dz',0	; Doszip directory
$name db '%n',0		; Name part of file
$TYPE db '%ext',0	; Extension of file
$SSTR db '%s',0		; Search string
$FCID db '%id',0	; File index or loop counter
$OFFS db '%o',0		; Offset string
$TMP1 db 7,1,0		; unlikely combination 1 '\\'
$TMP2 db 7,2,0		; unlikely combination 2 '\%'

cp_ziplst db	'ziplst',0
$FORSLASH db	'/',0
mklsubcnt dd	0
cp_mklist db	'MKList',0

GCMD_mklist	label dword
GCMD KEY_F9,	mklevent_LOAD
		dd	0

.code

mklevent_FILTER:
	call cmfilter
	mov edx,tdialog
	mov dx,[ebx+4]
	add dx,0A1Ch
	mov cl,dh
	mov eax,' '
	.if filter
	    mov al,7
	.endif
	invoke scputw,edx,ecx,1,eax
	mov eax,_C_NORMAL
	ret

mklevent_LOAD proc private uses esi edi ebx
local string[256]:byte
local dialog:dword
	mov eax,tdialog
	mov dialog,eax
	mov eax,tdialog
	mov al,[eax].S_DOBJ.dl_index
	.if !al || al == 2
	    invoke tools_idd,128,addr string,addr cp_mklist
	    mov esi,eax
	    call msloop
	    mov eax,_C_NORMAL
	    .if esi && esi != MOUSECMD
		mov edi,dialog
		mov esi,[edi+MKLID_FORMAT].S_TOBJ.to_data
		lea edi,string
		.if strchr(edi,'@')
		    xchg edi,eax
		    mov byte ptr [edi],0
		    mov edx,dialog
		    .if eax != edi
			invoke strcpy,[edx+MKLID_LIST].S_TOBJ.to_data,eax
		    .endif
		    inc edi
		.endif
		invoke strcpy,esi,edi
		mov eax,_C_REOPEN
	    .endif
	.else
	    mov eax,_C_NORMAL
	.endif
	ret
mklevent_LOAD endp

mklistidd proc uses ebx edi
	.if rsopen(IDD_DZMKList)
	    mov ebx,eax
	    mov [ebx].S_TOBJ.to_proc[MKLID_FILTER],mklevent_FILTER
	    mov edi,[ebx+MKLID_LIST].S_TOBJ.to_data
	    mov al,mklist.mkl_append
	    and al,_O_FLAGB
	    or  [ebx+MKLID_APPEND],al
	    mov [ebx+MKLID_APPEND].S_TOBJ.to_data,offset GCMD_mklist
	    mov al,mklist.mkl_unix
	    and al,_O_FLAGB
	    or  [ebx+MKLID_UNIX],al
	    mov al,mklist.mkl_excl_cd
	    and al,_O_FLAGB
	    or  [ebx+MKLID_EXLCD],al
	    mov al,mklist.mkl_excl_drv
	    and al,_O_FLAGB
	    or  [ebx+MKLID_EXLDRV],al
	    invoke strcpy,[ebx+MKLID_FORMAT].S_TOBJ.to_data,addr format_lst
	    invoke strcpy,edi,addr filelist_bat
	    xor eax,eax
	    mov mklist.mkl_offset,eax
	    invoke dlinit,ebx
	    .if dlevent(ebx)
		sub eax,eax
		mov mklist.mkl_count,eax
		mov mklist.mkl_macro,1
		mov al,[ebx+MKLID_APPEND]
		and al,_O_FLAGB
		mov mklist.mkl_append,al
		mov al,[ebx+MKLID_UNIX]
		and al,_O_FLAGB
		mov mklist.mkl_unix,al
		mov al,[ebx+MKLID_EXLCD]
		and al,_O_FLAGB
		mov mklist.mkl_excl_cd,al
		mov al,[ebx+MKLID_EXLDRV]
		and al,_O_FLAGB
		mov mklist.mkl_excl_drv,al
		invoke strcpy,addr format_lst,[ebx].S_TOBJ.to_data[MKLID_FORMAT]
		invoke strcpy,addr filelist_bat,edi
		invoke dlclose,ebx
		.if mklist.mkl_append
		    .if filexist(edi) == 1
			.if openfile(edi,M_WRONLY,A_OPEN)
			    mov mklist.mkl_handle,eax
			    invoke lseek,eax,0,SEEK_END
			    mov eax,1
			.endif
			jmp @F
		    .elseif eax == 2
			sub eax,eax
			jmp @F
		    .endif
		.endif
	    .else
		invoke dlclose,ebx
		sub eax,eax
		jmp @F
	    .endif
	    invoke ogetouth,edi,M_WRONLY
	    mov mklist.mkl_handle,eax
	    test eax,eax
	.endif
      @@:
	ret
mklistidd endp

expand_macro proc private
	push	ecx	; new
	invoke  strlen,edx
	pop	ecx
	invoke  strxchg,ebp,edx,ecx,eax
	ret
expand_macro endp

mklistadd proc		; AX=file name
	push	ebp
	sub	esp,WMAXPATH*3
	mov	ebp,esp
	push	esi
	push	edi
	mov	edx,eax
	xor	eax,eax
	mov	ecx,eax
	inc mklist.mkl_count
	.if mklist.mkl_excl_drv != al && byte ptr [edx+1] == ':'
	    add ecx,2
	.endif
	add edx,ecx
	.if mklist.mkl_excl_cd != al
	    add edx,mklist.mkl_offspath
	    sub edx,ecx
	.endif
	.if mklist.mkl_unix != al
	    invoke dostounix,edx
	    mov edx,eax
	.endif
	lea edi,[ebp+WMAXPATH*2]
	invoke strcpy,edi,edx
	invoke strcpy,ebp,addr format_lst
	.if mklist.mkl_macro != 1
	    invoke strcpy,eax,edi
	    jmp mklistadd_nomacro
	.endif
	mov	eax,edx
	mov	edx,offset $BACK	; '\\'
	mov	ecx,offset $TMP1	; --> 07 01
	call	expand_macro
	mov	edx,offset $CRLF	; '\n'
	mov	ecx,offset CRLF$	; --> 0D 0A
	call	expand_macro
	mov	edx,offset $TAB9	; '\t'
	mov	ecx,offset TAB9$	; --> 09
	call	expand_macro
	mov	edx,offset $SIGN	; '\%'
	mov	ecx,offset $TMP2	; --> 07 02
	call	expand_macro
	mov	edx,offset $TMP1	; 07 01
	mov	ecx,offset BACK$	; --> '\'
	call	expand_macro
	mov	edx,offset $HOME
	mov	ecx,offset configpath
	call	expand_macro
	mov	edx,offset $FILE
	mov	ecx,edi
	call	expand_macro
	invoke  strfn,edi
	mov	esi,eax
	invoke  strrchr,eax,'.'
	mov	edi,eax
	.if ZERO?
	    mov eax,offset NULL$
	.endif
	mov ecx,eax
	mov edx,offset $TYPE
	call expand_macro
	sub eax,eax
	.if eax != edi
	    mov [edi],al
	.endif
	mov ecx,esi
	mov edx,offset $name
	call expand_macro
	lea edi,[ebp+WMAXPATH*2]
	.if edi != esi
	    mov ecx,edi
	    xor eax,eax
	    mov [esi-1],al
	.else
	    mov ecx,offset NULL$
	.endif
	mov edx,offset $PATH
	call expand_macro
	xor eax,eax
	mov ecx,edi
	mov edx,edi
	add edx,mklist.mkl_offspath
	.if edx != ecx
	    dec edx
	.endif
	mov	[edx],al
	mov	edx,offset $CURD
	call	expand_macro
	mov	edx,offset $SSTR
	mov	ecx,offset searchstring
	call	expand_macro
	mov	eax,mklist.mkl_count
	dec	eax
	invoke  sprintf,edi,addr format_u,eax
	mov	edx,offset $FCID
	mov	ecx,edi
	call	expand_macro
	invoke  sprintf,edi,addr format_lu,mklist.mkl_offset
	mov	edx,offset $OFFS
	mov	ecx,edi
	call	expand_macro
	mov	edx,offset $TMP2 ; 07 02 00
	mov	ecx,offset SIGN$ ; --> '%'
	call	expand_macro
    mklistadd_nomacro:
	invoke strlen,ebp
	.if oswrite(mklist.mkl_handle,ebp,eax)
	    mov eax,0
	    .if mklist.mkl_macro != 1
		invoke oswrite,mklist.mkl_handle,addr CRLF$, 2
		sub eax,2
		.if eax
		    inc eax
		.endif
	    .endif
	.else
	   inc eax
	.endif
    mklistadd_end:
	pop	edi
	pop	esi
	add	esp,WMAXPATH*3
	pop	ebp
	test	eax,eax
	ret
mklistadd endp

fp_mklist proc private path:dword, wblk:dword
	.if filter_wblk(wblk)
	    mov eax,wblk
	    add eax,S_WFBLK.wf_name
	    invoke strfcat,addr __srcfile,path,eax
	    .if !progress_set(0,eax,1)
		mov eax,offset __srcfile
		call mklistadd
	    .endif
	.endif
	ret
fp_mklist endp

mksublist proc private uses esi edi zip_list:dword, path:dword
	mov eax,1
	mov mklist.mkl_macro,al
	.if zip_list == eax
	    mov mklist.mkl_excl_cd,al
	    mov eax,offset cp_ziplst
	    dec mklist.mkl_macro
	.else
	    call mklistidd
	    lea eax,filelist_bat
	    jz mksublist_end
	.endif
	mov fp_fileblock,offset fp_mklist
	mov fp_directory,offset scan_files
	invoke progress_open,eax,0
	invoke strlen,path
	mov edx,path
	add edx,eax
	.if byte ptr [edx-1] != '\'
	    inc eax
	.endif
	mov mklist.mkl_offspath,eax
	.if cpanel_findfirst()
	  @@:
	    .if ecx & _FB_ARCHEXT
		mov mklist.mkl_offspath,0
	    .endif
	    mov edi,ecx
	    mov esi,edx
	    invoke strfcat,addr __outpath,path,eax
	    .if !progress_set(0,eax,1)
		.if edi & _A_SUBDIR
		    .if edi & _FB_ARCHIVE
			invoke strcat,addr __outpath,addr BACK$
			.if mklist.mkl_mask
			    mov edx,cpanel
			    mov edx,[edx].S_PANEL.pn_wsub
			    invoke strcat,eax,[edx].S_WSUB.ws_mask
			.endif
			call mklistadd
			inc mklsubcnt
		    .else
			.if scansub(addr __outpath,addr cp_stdmask,0)
			    jmp @F
			.endif
		    .endif
		.else
		    .if filter_fblk(esi)
			mov eax,offset __outpath
			call mklistadd
		    .endif
		.endif
		and [esi].S_FBLK.fb_flag,not _FB_SELECTED
		mov eax,cpanel
		call panel_findnext
		jnz @B
	    .endif
	  @@:
	    push eax
	    call progress_close
	    invoke close,mklist.mkl_handle
	    pop eax
	.else
	    jmp @B
	.endif
    mksublist_end:
	ret
mksublist endp

mkwslist proc private uses esi
	mov esi,eax
	.if cpanel_findfirst()
	    mov eax,cpanel
	    mov edx,[eax]
	    mov eax,[edx]
	    .if eax & _W_ARCHIVE
		add edx,S_PATH.wp_arch
	    .else
		add edx,S_PATH.wp_path
	    .endif
	    invoke mksublist,esi,edx
	.endif
	ret
mkwslist endp

cmmklist proc
	sub	eax,eax
	call	mkwslist
	ret
cmmklist endp

ifdef __ZIP__

mkziplst_open proc
	sub esp,WMAXPATH
	mov eax,esp
	invoke strfcat,eax,envtemp,addr cp_ziplst
	invoke ogetouth,eax,M_WRONLY
	mov edx,esp
	add esp,WMAXPATH
	mov mklist.mkl_handle,eax
	.if eax
	    inc eax
	    .if eax
		or cflag,_C_DELTEMP
		mov eax,1
	    .endif
	.endif
	ret
mkziplst_open endp

mkziplst proc
	sub	eax,eax
	mov	mklsubcnt,eax
	inc	eax
	call	mkwslist
	mov	edx,mklsubcnt
	ret
mkziplst endp

endif
	END
